
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

static struct static_route *this_srt;



/* Line 189 of yacc.c  */
#line 225 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     GEQ = 261,
     LEQ = 262,
     NEQ = 263,
     AND = 264,
     OR = 265,
     PO = 266,
     PC = 267,
     NUM = 268,
     ENUM = 269,
     RTRID = 270,
     IPA = 271,
     SYM = 272,
     TEXT = 273,
     PREFIX_DUMMY = 274,
     DEFINE = 275,
     ON = 276,
     OFF = 277,
     YES = 278,
     NO = 279,
     LOG = 280,
     SYSLOG = 281,
     ALL = 282,
     DEBUG = 283,
     TRACE = 284,
     INFO = 285,
     REMOTE = 286,
     WARNING = 287,
     ERROR = 288,
     AUTH = 289,
     FATAL = 290,
     BUG = 291,
     STDERR = 292,
     SOFT = 293,
     CONFIGURE = 294,
     DOWN = 295,
     KERNEL = 296,
     PERSIST = 297,
     SCAN = 298,
     TIME = 299,
     LEARN = 300,
     DEVICE = 301,
     ASYNC = 302,
     TABLE = 303,
     ROUTER = 304,
     ID = 305,
     PROTOCOL = 306,
     PREFERENCE = 307,
     DISABLED = 308,
     DIRECT = 309,
     INTERFACE = 310,
     IMPORT = 311,
     EXPORT = 312,
     FILTER = 313,
     NONE = 314,
     STATES = 315,
     ROUTES = 316,
     FILTERS = 317,
     PASSWORD = 318,
     FROM = 319,
     PASSIVE = 320,
     TO = 321,
     EVENTS = 322,
     PACKETS = 323,
     PROTOCOLS = 324,
     INTERFACES = 325,
     PRIMARY = 326,
     STATS = 327,
     COUNT = 328,
     FOR = 329,
     COMMANDS = 330,
     PREEXPORT = 331,
     GENERATE = 332,
     LISTEN = 333,
     BGP = 334,
     V6ONLY = 335,
     ADDRESS = 336,
     PORT = 337,
     PASSWORDS = 338,
     DESCRIPTION = 339,
     SHOW = 340,
     STATUS = 341,
     SUMMARY = 342,
     ROUTE = 343,
     SYMBOLS = 344,
     DUMP = 345,
     RESOURCES = 346,
     SOCKETS = 347,
     NEIGHBORS = 348,
     ATTRIBUTES = 349,
     ECHO = 350,
     DISABLE = 351,
     ENABLE = 352,
     RESTART = 353,
     FUNCTION = 354,
     PRINT = 355,
     PRINTN = 356,
     UNSET = 357,
     RETURN = 358,
     ACCEPT = 359,
     REJECT = 360,
     QUITBIRD = 361,
     INT = 362,
     BOOL = 363,
     IP = 364,
     PREFIX = 365,
     PAIR = 366,
     SET = 367,
     STRING = 368,
     BGPMASK = 369,
     BGPPATH = 370,
     CLIST = 371,
     IF = 372,
     THEN = 373,
     ELSE = 374,
     CASE = 375,
     TRUE = 376,
     FALSE = 377,
     GW = 378,
     NET = 379,
     MASK = 380,
     PROTO = 381,
     SOURCE = 382,
     SCOPE = 383,
     CAST = 384,
     DEST = 385,
     LEN = 386,
     DEFINED = 387,
     ADD = 388,
     DELETE = 389,
     CONTAINS = 390,
     RESET = 391,
     PREPEND = 392,
     FIRST = 393,
     LAST = 394,
     MATCH = 395,
     EMPTY = 396,
     WHERE = 397,
     EVAL = 398,
     LOCAL = 399,
     NEIGHBOR = 400,
     AS = 401,
     HOLD = 402,
     CONNECT = 403,
     RETRY = 404,
     KEEPALIVE = 405,
     MULTIHOP = 406,
     STARTUP = 407,
     VIA = 408,
     NEXT = 409,
     HOP = 410,
     SELF = 411,
     DEFAULT = 412,
     PATH = 413,
     METRIC = 414,
     START = 415,
     DELAY = 416,
     FORGET = 417,
     WAIT = 418,
     AFTER = 419,
     BGP_PATH = 420,
     BGP_LOCAL_PREF = 421,
     BGP_MED = 422,
     BGP_ORIGIN = 423,
     BGP_NEXT_HOP = 424,
     BGP_ATOMIC_AGGR = 425,
     BGP_AGGREGATOR = 426,
     BGP_COMMUNITY = 427,
     RR = 428,
     RS = 429,
     CLIENT = 430,
     CLUSTER = 431,
     AS4 = 432,
     ADVERTISE = 433,
     IPV4 = 434,
     CAPABILITIES = 435,
     LIMIT = 436,
     PREFER = 437,
     OLDER = 438,
     MISSING = 439,
     LLADDR = 440,
     DROP = 441,
     IGNORE = 442,
     OSPF = 443,
     AREA = 444,
     OSPF_METRIC1 = 445,
     OSPF_METRIC2 = 446,
     OSPF_TAG = 447,
     BROADCAST = 448,
     RFC1583COMPAT = 449,
     STUB = 450,
     TICK = 451,
     COST = 452,
     RETRANSMIT = 453,
     HELLO = 454,
     TRANSMIT = 455,
     PRIORITY = 456,
     DEAD = 457,
     NONBROADCAST = 458,
     POINTOPOINT = 459,
     TYPE = 460,
     SIMPLE = 461,
     AUTHENTICATION = 462,
     STRICT = 463,
     CRYPTOGRAPHIC = 464,
     ELIGIBLE = 465,
     POLL = 466,
     NETWORKS = 467,
     HIDDEN = 468,
     VIRTUAL = 469,
     LINK = 470,
     RX = 471,
     BUFFER = 472,
     LARGE = 473,
     NORMAL = 474,
     STUBNET = 475,
     TOPOLOGY = 476,
     STATE = 477,
     PIPE = 478,
     PEER = 479,
     MODE = 480,
     OPAQUE = 481,
     TRANSPARENT = 482,
     RIP = 483,
     INFINITY = 484,
     PERIOD = 485,
     GARBAGE = 486,
     TIMEOUT = 487,
     MULTICAST = 488,
     QUIET = 489,
     NOLISTEN = 490,
     VERSION1 = 491,
     PLAINTEXT = 492,
     MD5 = 493,
     HONOR = 494,
     NEVER = 495,
     ALWAYS = 496,
     RIP_METRIC = 497,
     RIP_TAG = 498,
     STATIC = 499,
     PROHIBIT = 500
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;



/* Line 214 of yacc.c  */
#line 528 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 540 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  42
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1578

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  267
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  180
/* YYNRULES -- Number of rules.  */
#define YYNRULES  551
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1031

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   500

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     257,   258,    27,    25,   263,    26,    24,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   260,   259,
      21,    20,    22,   264,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   265,     2,   266,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   261,     2,   262,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    73,
      75,    77,    79,    83,    85,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   111,   116,   119,   120,   122,
     125,   128,   132,   135,   138,   142,   146,   150,   155,   157,
     159,   161,   166,   167,   170,   173,   176,   178,   181,   183,
     184,   186,   187,   190,   193,   196,   199,   202,   205,   209,
     212,   215,   217,   219,   221,   223,   227,   231,   232,   234,
     236,   239,   240,   242,   246,   248,   252,   255,   259,   263,
     267,   268,   272,   274,   276,   280,   282,   286,   288,   290,
     292,   294,   296,   298,   303,   305,   306,   310,   315,   317,
     320,   321,   327,   333,   339,   345,   350,   354,   359,   365,
     367,   368,   372,   377,   382,   383,   386,   390,   394,   398,
     401,   404,   407,   411,   415,   418,   421,   423,   425,   430,
     434,   438,   442,   446,   450,   454,   458,   463,   465,   467,
     469,   470,   472,   476,   480,   484,   489,   491,   493,   495,
     496,   501,   504,   506,   508,   510,   512,   514,   516,   518,
     520,   522,   525,   528,   529,   533,   535,   539,   541,   543,
     545,   548,   552,   555,   560,   561,   567,   568,   571,   573,
     577,   583,   585,   587,   589,   591,   593,   595,   600,   602,
     606,   610,   612,   615,   618,   625,   627,   631,   632,   637,
     641,   643,   647,   651,   655,   658,   661,   664,   667,   668,
     671,   674,   675,   681,   683,   685,   687,   689,   691,   693,
     697,   701,   703,   705,   706,   711,   713,   715,   717,   719,
     721,   723,   725,   727,   729,   733,   737,   741,   745,   749,
     753,   757,   761,   765,   769,   773,   777,   781,   785,   788,
     793,   795,   797,   799,   801,   804,   807,   811,   815,   822,
     826,   830,   834,   838,   845,   852,   859,   864,   866,   868,
     870,   872,   874,   876,   878,   879,   881,   885,   887,   891,
     892,   894,   899,   906,   911,   915,   921,   927,   932,   939,
     943,   946,   952,   958,   967,   976,   985,   988,   992,   996,
    1002,  1009,  1016,  1021,  1026,  1032,  1039,  1046,  1052,  1059,
    1065,  1071,  1077,  1083,  1089,  1095,  1101,  1107,  1113,  1120,
    1127,  1136,  1143,  1149,  1154,  1160,  1165,  1171,  1176,  1179,
    1183,  1187,  1189,  1192,  1195,  1198,  1202,  1205,  1206,  1210,
    1214,  1217,  1222,  1225,  1228,  1230,  1235,  1237,  1239,  1240,
    1244,  1247,  1250,  1253,  1258,  1260,  1261,  1265,  1266,  1269,
    1272,  1276,  1279,  1282,  1286,  1289,  1292,  1295,  1297,  1301,
    1304,  1307,  1310,  1313,  1317,  1320,  1323,  1326,  1330,  1333,
    1336,  1339,  1343,  1346,  1351,  1354,  1357,  1360,  1364,  1368,
    1372,  1374,  1375,  1378,  1380,  1382,  1385,  1389,  1390,  1393,
    1395,  1397,  1400,  1404,  1405,  1406,  1410,  1411,  1415,  1419,
    1421,  1422,  1427,  1434,  1441,  1448,  1455,  1458,  1462,  1466,
    1472,  1477,  1482,  1485,  1489,  1493,  1498,  1503,  1508,  1514,
    1520,  1525,  1529,  1534,  1539,  1544,  1549,  1551,  1553,  1555,
    1557,  1559,  1561,  1563,  1565,  1566,  1569,  1572,  1573,  1577,
    1578,  1582,  1583,  1587,  1590,  1594,  1598,  1602,  1605,  1609,
    1613,  1616,  1619,  1622,  1627,  1629,  1631,  1633,  1635,  1637,
    1639,  1641,  1643,  1645,  1647,  1649,  1651,  1653,  1655,  1657,
    1659,  1661,  1663,  1665,  1667,  1669,  1671,  1673,  1675,  1677,
    1679,  1681,  1683,  1685,  1687,  1689,  1691,  1693,  1695,  1697,
    1699,  1701,  1703,  1705,  1708,  1711,  1714,  1717,  1720,  1723,
    1726,  1729,  1733,  1737,  1741,  1745,  1749,  1753,  1757,  1759,
    1761,  1763,  1765,  1767,  1769,  1771,  1773,  1775,  1777,  1779,
    1781,  1783
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     268,     0,    -1,   269,     3,    -1,     4,   442,    -1,    -1,
     269,   441,    -1,    13,    -1,   257,   382,   258,    -1,    17,
      -1,    31,    17,    20,   270,   259,    -1,    31,    17,    20,
      16,   259,    -1,   270,    -1,    32,    -1,    34,    -1,    33,
      -1,    35,    -1,    -1,    16,    -1,    17,    -1,   273,   276,
      -1,   274,    -1,   273,    -1,    28,   270,    -1,   260,   273,
      -1,    18,    -1,    18,    -1,    -1,    36,   280,   281,   259,
      -1,    18,    -1,    37,    -1,    48,    -1,    38,    -1,   261,
     282,   262,    -1,   283,    -1,   282,   263,   283,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    50,   287,     3,
      -1,    50,    49,   287,     3,    -1,    51,     3,    -1,    -1,
      18,    -1,   299,    52,    -1,    53,   272,    -1,    54,    55,
     270,    -1,    56,   272,    -1,   299,    57,    -1,    54,    55,
     270,    -1,    82,   278,   275,    -1,    52,    59,   270,    -1,
      60,    61,   294,   259,    -1,    13,    -1,    15,    -1,    16,
      -1,    89,    90,   296,   259,    -1,    -1,   296,   297,    -1,
      92,   273,    -1,    93,   270,    -1,    91,    -1,    59,    17,
      -1,    62,    -1,    -1,    17,    -1,    -1,    63,   270,    -1,
      64,   272,    -1,    39,   314,    -1,    67,   302,    -1,    68,
     302,    -1,    59,   303,    -1,    60,    61,   294,    -1,    95,
      18,    -1,    69,   355,    -1,   356,    -1,    38,    -1,    70,
      -1,    17,    -1,    39,    80,   314,    -1,    39,    86,   270,
      -1,    -1,    18,    -1,   274,    -1,    18,   274,    -1,    -1,
      26,    -1,   305,   307,   306,    -1,   308,    -1,   309,   263,
     308,    -1,   299,    65,    -1,   310,   300,   261,    -1,   311,
     301,   259,    -1,   311,   313,   259,    -1,    -1,    66,   312,
     309,    -1,    38,    -1,    33,    -1,   261,   315,   262,    -1,
     316,    -1,   315,   263,   316,    -1,    71,    -1,    72,    -1,
      73,    -1,    81,    -1,    78,    -1,    79,    -1,    94,   261,
     318,   262,    -1,   319,    -1,    -1,   319,   259,   318,    -1,
     320,   261,   321,   262,    -1,   320,    -1,    74,    18,    -1,
      -1,    88,    75,   277,   259,   321,    -1,    88,    77,   277,
     259,   321,    -1,   115,    75,   277,   259,   321,    -1,   115,
      77,   277,   259,   321,    -1,    61,   270,   259,   321,    -1,
      96,    97,     3,    -1,    96,    80,   325,     3,    -1,    96,
      80,    38,   325,     3,    -1,    17,    -1,    -1,    96,    81,
       3,    -1,    96,    81,    98,     3,    -1,    96,    99,   329,
       3,    -1,    -1,   329,   274,    -1,   329,    85,   275,    -1,
     329,    59,    17,    -1,   329,    69,   355,    -1,   329,   356,
      -1,   329,    38,    -1,   329,    82,    -1,   329,   330,    17,
      -1,   329,    62,    17,    -1,   329,    83,    -1,   329,    84,
      -1,    87,    -1,    68,    -1,    96,   100,   325,     3,    -1,
     101,   102,     3,    -1,   101,   103,     3,    -1,   101,    81,
       3,    -1,   101,   104,     3,    -1,   101,   105,     3,    -1,
     101,    72,     3,    -1,   101,    80,     3,    -1,   106,   340,
     341,     3,    -1,    38,    -1,    33,    -1,    13,    -1,    -1,
      13,    -1,   107,   346,     3,    -1,   108,   346,     3,    -1,
     109,   346,     3,    -1,    39,   346,   314,     3,    -1,    17,
      -1,    38,    -1,    18,    -1,    -1,    69,    17,   348,   354,
      -1,   154,   382,    -1,   118,    -1,   119,    -1,   120,    -1,
     121,    -1,   122,    -1,   124,    -1,   125,    -1,   126,    -1,
     127,    -1,   350,   123,    -1,   350,    17,    -1,    -1,   351,
     259,   352,    -1,   351,    -1,   353,   259,   351,    -1,   358,
      -1,    17,    -1,   354,    -1,   153,   382,    -1,   257,   353,
     258,    -1,   257,   258,    -1,   352,   261,   361,   262,    -1,
      -1,   110,    17,   360,   357,   358,    -1,    -1,   388,   361,
      -1,   388,    -1,   261,   361,   262,    -1,   257,    13,   263,
      13,   258,    -1,    16,    -1,    13,    -1,   363,    -1,   364,
      -1,    14,    -1,   365,    -1,   365,    24,    24,   365,    -1,
     366,    -1,   367,   263,   366,    -1,    16,    28,    13,    -1,
     368,    -1,   368,    25,    -1,   368,    26,    -1,   368,   261,
      13,   263,    13,   262,    -1,   369,    -1,   370,   263,   369,
      -1,    -1,   366,   260,   361,   371,    -1,   130,   260,   361,
      -1,   380,    -1,   257,   382,   258,    -1,    11,   374,    12,
      -1,    28,   375,    28,    -1,    13,   374,    -1,    27,   374,
      -1,   264,   374,    -1,   372,   374,    -1,    -1,    13,   375,
      -1,   264,   375,    -1,    -1,   257,   382,   263,   382,   258,
      -1,    13,    -1,   132,    -1,   133,    -1,    18,    -1,   364,
      -1,   368,    -1,   265,   367,   266,    -1,   265,   370,   266,
      -1,    14,    -1,   373,    -1,    -1,    17,   257,   387,   258,
      -1,    17,    -1,    75,    -1,   134,    -1,   135,    -1,   137,
      -1,   138,    -1,   139,    -1,   140,    -1,   141,    -1,   257,
     382,   258,    -1,   382,    25,   382,    -1,   382,    26,   382,
      -1,   382,    27,   382,    -1,   382,    28,   382,    -1,   382,
       9,   382,    -1,   382,    10,   382,    -1,   382,    20,   382,
      -1,   382,     8,   382,    -1,   382,    21,   382,    -1,   382,
       7,   382,    -1,   382,    22,   382,    -1,   382,     6,   382,
      -1,   382,    23,   382,    -1,    30,   382,    -1,   143,   257,
     382,   258,    -1,   380,    -1,   377,    -1,   376,    -1,    63,
      -1,   378,   381,    -1,   378,   446,    -1,   382,    24,   120,
      -1,   382,    24,   142,    -1,   382,    24,   136,   257,   382,
     258,    -1,   382,    24,   149,    -1,   382,    24,   150,    -1,
      25,   152,    25,    -1,    26,   152,    26,    -1,   148,   257,
     382,   263,   382,   258,    -1,   144,   257,   382,   263,   382,
     258,    -1,   145,   257,   382,   263,   382,   258,    -1,    17,
     257,   387,   258,    -1,   117,    -1,   115,    -1,   116,    -1,
      44,    -1,   111,    -1,   112,    -1,   382,    -1,    -1,   384,
      -1,   384,   263,   385,    -1,   382,    -1,   382,   263,   386,
      -1,    -1,   386,    -1,   128,   382,   129,   362,    -1,   128,
     382,   129,   362,   130,   362,    -1,    17,    20,   382,   259,
      -1,   114,   382,   259,    -1,   378,   446,    20,   382,   259,
      -1,   378,   381,    20,   382,   259,    -1,    63,    20,   382,
     259,    -1,   113,   257,   378,   446,   258,   259,    -1,   383,
     385,   259,    -1,   379,   259,    -1,   131,   382,   261,   371,
     262,    -1,   378,   446,    24,   152,   259,    -1,   378,   446,
      24,   148,   257,   382,   258,   259,    -1,   378,   446,    24,
     144,   257,   382,   258,   259,    -1,   378,   446,    24,   145,
     257,   382,   258,   259,    -1,   299,    90,    -1,   389,   300,
     261,    -1,   390,   301,   259,    -1,   390,   155,   157,   270,
     259,    -1,   390,   156,   273,   157,   270,   259,    -1,   390,
     184,   187,    61,   270,   259,    -1,   390,   184,   186,   259,
      -1,   390,   185,   186,   259,    -1,   390,   158,    55,   270,
     259,    -1,   390,   163,   158,    55,   270,   259,    -1,   390,
     159,   160,    55,   270,   259,    -1,   390,   161,    55,   270,
     259,    -1,   390,   162,   270,   164,   273,   259,    -1,   390,
     165,   166,   167,   259,    -1,   390,   195,   196,   167,   259,
      -1,   390,   195,   196,   197,   259,    -1,   390,   195,   196,
     198,   259,    -1,   390,   169,   170,   272,   259,    -1,   390,
     193,   194,   272,   259,    -1,   390,   168,   178,   270,   259,
      -1,   390,   168,   177,   270,   259,    -1,   390,   138,    92,
     273,   259,    -1,   390,   171,   172,    55,   270,   259,    -1,
     390,    44,   173,    55,   270,   259,    -1,   390,    44,   174,
      55,   270,   263,   270,   259,    -1,   390,   107,   175,    44,
     272,   259,    -1,   390,   108,   188,   272,   259,    -1,   390,
     191,   272,   259,    -1,   390,   189,   190,   272,   259,    -1,
     390,    74,    18,   259,    -1,   390,    99,   192,   270,   259,
      -1,   390,    76,   272,   259,    -1,   299,   199,    -1,   391,
     300,   261,    -1,   392,   393,   259,    -1,   301,    -1,   205,
     272,    -1,   207,   270,    -1,   395,   262,    -1,   200,   294,
     261,    -1,   394,   396,    -1,    -1,   396,   397,   259,    -1,
     206,   208,   270,    -1,   206,   272,    -1,   223,   261,   407,
     262,    -1,   231,   398,    -1,    66,   418,    -1,   402,    -1,
     399,   261,   400,   262,    -1,   399,    -1,   274,    -1,    -1,
     400,   401,   259,    -1,   224,   272,    -1,    98,   272,    -1,
     208,   270,    -1,   405,   261,   403,   262,    -1,   405,    -1,
      -1,   403,   404,   259,    -1,    -1,   210,   270,    -1,   209,
     270,    -1,   211,   172,   270,    -1,   174,   270,    -1,   213,
     270,    -1,   213,    84,   270,    -1,   218,    70,    -1,   218,
     217,    -1,   218,   220,    -1,   317,    -1,   225,   226,   294,
      -1,   208,   270,    -1,   210,   270,    -1,   222,   270,    -1,
     209,   270,    -1,   211,   172,   270,    -1,   212,   270,    -1,
     174,   270,    -1,   213,   270,    -1,   213,    84,   270,    -1,
     216,   204,    -1,   216,   214,    -1,   216,   215,    -1,   219,
     214,   272,    -1,   206,   272,    -1,   104,   261,   411,   262,
      -1,   218,    70,    -1,   218,   217,    -1,   218,   220,    -1,
     227,   228,   229,    -1,   227,   228,   230,    -1,   227,   228,
     270,    -1,   317,    -1,    -1,   407,   408,    -1,   409,    -1,
     410,    -1,   274,   259,    -1,   274,   224,   259,    -1,    -1,
     411,   412,    -1,   413,    -1,   414,    -1,    16,   259,    -1,
      16,   221,   259,    -1,    -1,    -1,   416,   406,   259,    -1,
      -1,   261,   416,   262,    -1,   415,   309,   417,    -1,    18,
      -1,    -1,    96,   199,   325,     3,    -1,    96,   199,   104,
     325,   419,     3,    -1,    96,   199,    66,   325,   419,     3,
      -1,    96,   199,   232,   325,   419,     3,    -1,    96,   199,
     233,   325,   419,     3,    -1,   299,   234,    -1,   425,   300,
     261,    -1,   426,   301,   259,    -1,   426,   235,    59,    17,
     259,    -1,   426,   236,   237,   259,    -1,   426,   236,   238,
     259,    -1,   299,   239,    -1,   427,   300,   261,    -1,   428,
     301,   259,    -1,   428,   240,   270,   259,    -1,   428,    93,
     270,   259,    -1,   428,   241,   270,   259,    -1,   428,   242,
      55,   270,   259,    -1,   428,   243,    55,   270,   259,    -1,
     428,   218,   429,   259,    -1,   428,   317,   259,    -1,   428,
     250,   252,   259,    -1,   428,   250,   156,   259,    -1,   428,
     250,   251,   259,    -1,   428,    66,   435,   259,    -1,   248,
      -1,   249,    -1,    70,    -1,   204,    -1,   244,    -1,   245,
      -1,   246,    -1,   247,    -1,    -1,   170,   270,    -1,   236,
     430,    -1,    -1,   432,   431,   259,    -1,    -1,   261,   432,
     262,    -1,    -1,   434,   309,   433,    -1,   299,   255,    -1,
     436,   300,   261,    -1,   437,   301,   259,    -1,   437,   439,
     259,    -1,    99,   274,    -1,   438,   164,   273,    -1,   438,
     164,    18,    -1,   438,   197,    -1,   438,   116,    -1,   438,
     256,    -1,    96,   255,   325,     3,    -1,   259,    -1,   271,
      -1,   279,    -1,   293,    -1,   295,    -1,   298,    -1,   443,
      -1,   304,    -1,   347,    -1,   349,    -1,   359,    -1,   284,
      -1,   285,    -1,   286,    -1,   322,    -1,   323,    -1,   324,
      -1,   326,    -1,   327,    -1,   328,    -1,   331,    -1,   332,
      -1,   333,    -1,   334,    -1,   335,    -1,   336,    -1,   337,
      -1,   338,    -1,   339,    -1,   342,    -1,   343,    -1,   344,
      -1,   345,    -1,   420,    -1,   421,    -1,   422,    -1,   423,
      -1,   424,    -1,   440,    -1,   444,   262,    -1,   445,   262,
      -1,   311,   262,    -1,   390,   262,    -1,   392,   262,    -1,
     426,   262,    -1,   428,   262,    -1,   437,   262,    -1,   288,
     300,   261,    -1,   444,   301,   259,    -1,   444,   289,   259,
      -1,   444,   292,   259,    -1,   290,   300,   261,    -1,   445,
     301,   259,    -1,   445,   291,   259,    -1,     5,    -1,   176,
      -1,   177,    -1,   178,    -1,   179,    -1,   180,    -1,   181,
      -1,   182,    -1,   183,    -1,   201,    -1,   202,    -1,   203,
      -1,   253,    -1,   254,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   293,   293,   294,   297,   299,   306,   307,   308,   312,
     316,   325,   326,   327,   328,   329,   330,   336,   337,   344,
     351,   352,   356,   360,   367,   375,   376,   382,   391,   396,
     397,   401,   402,   406,   407,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   426,   429,   432,   436,   437,   445,
     461,   462,   466,   478,   491,   495,   508,   520,   526,   527,
     528,   539,   541,   543,   547,   548,   549,   556,   564,   568,
     574,   580,   582,   586,   587,   588,   589,   590,   591,   592,
     596,   597,   598,   599,   603,   611,   612,   618,   626,   627,
     628,   632,   633,   637,   642,   643,   650,   659,   660,   661,
     665,   674,   680,   681,   682,   686,   687,   691,   692,   693,
     694,   695,   696,   702,   703,   706,   708,   712,   713,   717,
     735,   736,   737,   738,   739,   740,   748,   751,   754,   758,
     759,   762,   765,   768,   772,   778,   784,   791,   796,   801,
     806,   810,   814,   824,   832,   836,   843,   844,   847,   851,
     853,   855,   857,   859,   861,   863,   866,   872,   873,   874,
     878,   879,   885,   887,   889,   893,   898,   899,   900,   906,
     906,   915,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   947,   958,   959,   966,   967,   974,   983,   987,
     991,  1015,  1016,  1020,  1026,  1026,  1039,  1040,  1051,  1054,
    1063,  1070,  1074,  1075,  1076,  1077,  1081,  1086,  1094,  1095,
    1099,  1106,  1107,  1108,  1109,  1116,  1117,  1120,  1121,  1126,
    1137,  1138,  1142,  1143,  1147,  1148,  1149,  1150,  1151,  1155,
    1156,  1157,  1161,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1193,  1197,  1220,  1253,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1282,  1283,  1284,  1286,  1288,  1290,  1292,  1293,  1294,  1295,
    1296,  1306,  1307,  1308,  1309,  1310,  1315,  1338,  1339,  1340,
    1341,  1342,  1343,  1347,  1350,  1351,  1352,  1361,  1368,  1377,
    1378,  1382,  1388,  1398,  1407,  1413,  1418,  1425,  1430,  1436,
    1437,  1438,  1446,  1448,  1449,  1450,  1456,  1474,  1475,  1476,
    1477,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1518,  1528,
    1529,  1533,  1534,  1535,  1536,  1539,  1551,  1554,  1556,  1560,
    1561,  1562,  1563,  1564,  1565,  1569,  1570,  1574,  1582,  1584,
    1588,  1589,  1590,  1594,  1595,  1598,  1600,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1616,  1638,
    1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,
    1659,  1662,  1664,  1668,  1669,  1671,  1680,  1690,  1692,  1696,
    1697,  1699,  1708,  1719,  1741,  1743,  1746,  1748,  1752,  1756,
    1757,  1761,  1764,  1767,  1770,  1773,  1779,  1787,  1788,  1789,
    1794,  1795,  1801,  1808,  1809,  1810,  1811,  1812,  1813,  1814,
    1815,  1816,  1817,  1818,  1819,  1820,  1824,  1825,  1826,  1831,
    1832,  1833,  1834,  1835,  1838,  1839,  1840,  1843,  1845,  1848,
    1850,  1854,  1863,  1870,  1877,  1878,  1879,  1882,  1891,  1895,
    1901,  1902,  1903,  1906,  1913,  1913,  1913,  1913,  1913,  1913,
    1913,  1913,  1913,  1913,  1913,  1914,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1916,  1916,  1916,  1916,  1917,  1917,  1917,  1918,  1918,
    1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1926,  1926,
    1926,  1926
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "RTRID",
  "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "'.'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "DEFINE", "ON", "OFF", "YES",
  "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE",
  "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE",
  "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE",
  "STATES", "ROUTES", "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP",
  "V6ONLY", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "SET", "STRING",
  "BGPMASK", "BGPPATH", "CLIST", "IF", "THEN", "ELSE", "CASE", "TRUE",
  "FALSE", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST", "DEST",
  "LEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL", "NEIGHBOR",
  "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP", "STARTUP",
  "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC", "START",
  "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER",
  "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT", "PREFER", "OLDER",
  "MISSING", "LLADDR", "DROP", "IGNORE", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "BROADCAST", "RFC1583COMPAT", "STUB", "TICK",
  "COST", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD",
  "NONBROADCAST", "POINTOPOINT", "TYPE", "SIMPLE", "AUTHENTICATION",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "'('", "')'", "';'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "log_file", "log_mask", "log_mask_list", "log_cat", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name", "kern_proto_start",
  "kern_item", "kif_proto_start", "kif_item", "nl_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "newtab", "proto_start",
  "proto_name", "proto_item", "imexport", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_DEBUG", "proto_patt",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "block", "cpair", "fipa",
  "set_atom", "set_item", "set_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_STATE", "pipe_proto_start",
  "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      61,    60,    62,   126,    46,    43,    45,    42,    47,    37,
      33,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,    40,    41,    59,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   267,   268,   268,   269,   269,   270,   270,   270,   271,
     271,   272,   272,   272,   272,   272,   272,   273,   273,   274,
     275,   275,   276,   276,   277,   278,   278,   279,   280,   280,
     280,   281,   281,   282,   282,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   284,   285,   286,   287,   287,   288,
     289,   289,   289,   290,   291,   291,   292,   293,   294,   294,
     294,   295,   296,   296,   297,   297,   297,   298,   299,   300,
     300,   301,   301,   301,   301,   301,   301,   301,   301,   301,
     302,   302,   302,   302,   303,   304,   304,   305,   306,   306,
     306,   307,   307,   308,   309,   309,   310,   311,   311,   311,
     312,   313,   314,   314,   314,   315,   315,   316,   316,   316,
     316,   316,   316,   317,   317,   318,   318,   319,   319,   320,
     321,   321,   321,   321,   321,   321,   322,   323,   324,   325,
     325,   326,   327,   328,   329,   329,   329,   329,   329,   329,
     329,   329,   329,   329,   329,   329,   330,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   340,   340,
     341,   341,   342,   343,   344,   345,   346,   346,   346,   348,
     347,   349,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   351,   352,   352,   353,   353,   354,   355,   355,
     356,   357,   357,   358,   360,   359,   361,   361,   362,   362,
     363,   364,   365,   365,   365,   365,   366,   366,   367,   367,
     368,   369,   369,   369,   369,   370,   370,   371,   371,   371,
     372,   372,   373,   373,   374,   374,   374,   374,   374,   375,
     375,   375,   376,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   378,   379,   380,   381,   381,   381,   381,
     381,   381,   381,   381,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   383,   383,   383,
     383,   383,   383,   384,   385,   385,   385,   386,   386,   387,
     387,   388,   388,   388,   388,   388,   388,   388,   388,   388,
     388,   388,   388,   388,   388,   388,   389,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   391,   392,
     392,   393,   393,   393,   393,   394,   395,   396,   396,   397,
     397,   397,   397,   397,   397,   398,   398,   399,   400,   400,
     401,   401,   401,   402,   402,   403,   403,   404,   404,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   405,   406,
     406,   406,   406,   406,   406,   406,   406,   406,   406,   406,
     406,   406,   406,   406,   406,   406,   406,   406,   406,   406,
     406,   407,   407,   408,   408,   409,   410,   411,   411,   412,
     412,   413,   414,   415,   416,   416,   417,   417,   418,   419,
     419,   420,   421,   422,   423,   424,   425,   426,   426,   426,
     426,   426,   427,   428,   428,   428,   428,   428,   428,   428,
     428,   428,   428,   428,   428,   428,   429,   429,   429,   430,
     430,   430,   430,   430,   431,   431,   431,   432,   432,   433,
     433,   434,   435,   436,   437,   437,   437,   438,   439,   439,
     439,   439,   439,   440,   441,   441,   441,   441,   441,   441,
     441,   441,   441,   441,   441,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   443,   443,   443,   443,   443,   443,   443,
     443,   444,   444,   444,   444,   445,   445,   445,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     4,     2,     0,     1,     2,
       2,     3,     2,     2,     3,     3,     3,     4,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     2,     1,     0,
       1,     0,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     1,     1,     1,     1,     3,     3,     0,     1,     1,
       2,     0,     1,     3,     1,     3,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     4,     5,     1,
       0,     3,     4,     4,     0,     2,     3,     3,     3,     2,
       2,     2,     3,     3,     2,     2,     1,     1,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     1,     1,
       0,     1,     3,     3,     3,     4,     1,     1,     1,     0,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     3,     1,     3,     1,     1,     1,
       2,     3,     2,     4,     0,     5,     0,     2,     1,     3,
       5,     1,     1,     1,     1,     1,     1,     4,     1,     3,
       3,     1,     2,     2,     6,     1,     3,     0,     4,     3,
       1,     3,     3,     3,     2,     2,     2,     2,     0,     2,
       2,     0,     5,     1,     1,     1,     1,     1,     1,     3,
       3,     1,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     6,     6,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     3,     1,     3,     0,
       1,     4,     6,     4,     3,     5,     5,     4,     6,     3,
       2,     5,     5,     8,     8,     8,     2,     3,     3,     5,
       6,     6,     4,     4,     5,     6,     6,     5,     6,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     6,     6,
       8,     6,     5,     4,     5,     4,     5,     4,     2,     3,
       3,     1,     2,     2,     2,     3,     2,     0,     3,     3,
       2,     4,     2,     2,     1,     4,     1,     1,     0,     3,
       2,     2,     2,     4,     1,     0,     3,     0,     2,     2,
       3,     2,     2,     3,     2,     2,     2,     1,     3,     2,
       2,     2,     2,     3,     2,     2,     2,     3,     2,     2,
       2,     3,     2,     4,     2,     2,     2,     3,     3,     3,
       1,     0,     2,     1,     1,     2,     3,     0,     2,     1,
       1,     2,     3,     0,     0,     3,     0,     3,     3,     1,
       0,     4,     6,     6,     6,     6,     2,     3,     3,     5,
       4,     4,     2,     3,     3,     4,     4,     4,     5,     5,
       4,     3,     4,     4,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     2,     0,     3,     0,
       3,     0,     3,     2,     3,     3,     3,     2,     3,     3,
       2,     2,     2,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,     3,     1,     2,     0,     0,     0,     0,     0,    68,
       0,     0,     0,   243,   484,   485,   486,    69,    69,   487,
     488,   489,     0,   491,    69,    71,   492,   493,   494,    69,
      71,    69,    71,    69,    71,    69,    71,    69,    71,     5,
     490,    71,    71,   166,   168,   167,     0,    48,    47,     0,
      46,   130,     0,     0,   134,   130,   130,   130,     0,     0,
       0,     0,     0,     0,     0,   159,   158,   157,   160,     0,
       0,     0,     0,    28,    29,    30,     0,     0,     0,    67,
       0,   169,    62,   194,   228,   233,   241,   201,   245,   236,
       0,     0,   231,   243,   273,   234,   235,     0,     0,     0,
       0,   243,     0,   237,   238,   242,   272,   271,     0,   270,
     171,    70,     0,     0,    49,    53,    96,   316,   348,   436,
     442,   473,     0,     0,     0,     0,     0,    16,   100,     0,
       0,     0,   525,     0,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,     0,     0,
     526,     0,     0,     0,    16,     0,   527,   351,     0,   357,
       0,     0,     0,     0,   528,     0,     0,   471,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   529,     0,     0,
     114,   118,     0,     0,   530,     0,     0,     0,     0,    16,
       0,    16,   523,     0,     0,     0,     0,    26,   524,     0,
       0,   103,   102,     0,     0,     0,    44,   129,   130,     0,
     131,     0,   126,     0,     0,   130,   130,   130,   130,     0,
       0,   154,   155,   151,   149,   150,   152,   153,   161,     0,
     162,   163,   164,     0,    31,     0,     0,    85,     6,     8,
     243,    86,    58,    59,    60,     0,   183,     0,     0,   228,
     245,   228,   243,   228,   228,     0,   220,     0,   243,     0,
       0,   231,   231,     0,   268,   243,   243,   243,   243,     0,
     202,   205,     0,   203,   204,   206,   208,     0,   211,   215,
       0,   538,   246,   247,   248,   249,   250,   251,   252,   253,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   274,   275,   243,   243,   243,   243,   243,
     243,   243,   243,   243,     0,   243,   243,   243,   243,   531,
     535,    97,    74,    84,    77,     0,    72,    12,    14,    13,
      15,    11,    73,    87,    82,   183,    83,   243,    75,    81,
      76,    79,    98,    99,   317,     0,     0,     0,     0,     0,
       0,    16,     0,     0,    17,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
      16,     0,    16,     0,   318,   349,     0,   352,   353,   350,
     356,   354,   437,     0,     0,     0,   438,   443,    87,     0,
     119,     0,   115,   458,   456,   457,     0,     0,     0,     0,
       0,     0,     0,     0,   444,   451,   120,   474,     0,   477,
     475,   481,     0,   480,   482,   476,     0,    50,     0,    52,
     533,   534,   532,     0,    25,     0,   537,   536,   107,   108,
     109,   111,   112,   110,     0,   105,   165,    45,     0,   127,
     132,   133,   140,     0,     0,   147,   183,   141,   144,   145,
       0,   146,   135,     0,   139,   148,   430,   430,   430,   430,
     431,   483,   156,     0,     0,    35,    36,    37,    38,    39,
      40,    41,    42,    43,     0,    33,    27,     0,    57,   172,
     173,   174,   175,   176,   177,   178,   179,   180,     0,     0,
       0,   170,   187,    66,     0,     0,    61,    63,     0,   183,
     224,   225,     0,   226,   227,   222,   210,   297,   300,     0,
     281,   282,   229,   230,   223,     0,     0,     0,     0,   254,
     243,     0,     0,     0,   239,   212,   213,     0,     0,   240,
     266,   264,   262,   259,   260,   261,   263,   265,   267,   276,
       0,   277,   279,   280,   255,   256,   257,   258,    78,    91,
      94,   101,   188,   189,    80,   190,     0,     0,   345,   347,
       0,    16,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,     0,   323,     0,
     343,     0,     0,     0,     0,   355,   423,    16,     0,     0,
       0,     0,   364,   374,     0,   440,   441,   469,   455,   446,
       0,     0,   450,   445,   447,     0,     0,   453,   454,   452,
       0,     0,     0,     0,     0,     0,    19,   479,   478,    56,
      51,    54,    21,    20,    55,   104,     0,   128,   137,   143,
     138,   136,   142,   429,     0,     0,     0,     0,    10,     9,
      32,     0,     7,   182,   181,   183,   243,    64,    65,   192,
     185,     0,   195,   221,   243,   286,   269,   243,   243,   243,
       0,     0,     0,   201,   209,     0,     0,   216,   243,    92,
       0,    87,     0,     0,   346,     0,   342,   337,   319,     0,
     324,     0,   327,     0,     0,   329,   336,   335,   333,     0,
       0,   344,   334,   330,   331,   332,    87,   363,     0,   360,
     411,     0,   367,   362,   366,   358,   375,   439,   467,   472,
     113,   115,   448,   449,     0,     0,     0,     0,     0,   117,
      22,    23,   106,   433,   432,   434,   435,    34,   184,     0,
     290,     0,   291,   292,     0,   243,   288,   289,   287,   243,
     243,     0,     0,     0,   243,   243,   191,     0,   298,     0,
       0,     0,   232,     0,   207,     0,     0,    88,    89,    93,
      95,   339,     0,   341,   320,   326,   328,   325,   338,   321,
     426,   359,     0,   388,   368,   377,   464,   116,   120,    24,
       0,     0,     0,     0,   243,   243,   243,   243,     0,     0,
       0,   193,     0,     0,   310,   293,   295,     0,   197,   186,
     284,   285,   283,   200,     0,   278,    90,     0,   424,   428,
     361,     0,   412,   413,   414,     0,     0,     0,     0,     0,
       0,     0,   373,   387,     0,     0,     0,   470,     0,   125,
     120,   120,   120,   120,     0,     0,     0,     0,   304,   243,
     217,   243,   243,     0,   243,   309,   214,   340,     0,     0,
     415,    16,     0,    16,   365,     0,   381,   379,   378,     0,
       0,   382,   384,   385,   386,   376,   465,   459,   460,   461,
     462,   463,   466,   468,   121,   122,   123,   124,   303,   244,
     307,     0,   243,   301,   198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   296,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   427,
     410,     0,   416,   371,   372,   370,   369,   380,   383,     0,
       0,   243,   243,   243,   311,   306,   305,   243,   243,   243,
     312,   417,   395,   402,   389,   392,   390,     0,   394,     0,
     396,   398,   399,   400,   404,   405,   406,    16,   391,     0,
     425,   308,   199,   302,   219,   217,     0,     0,     0,     0,
     393,   397,   401,   407,   408,   409,   218,     0,     0,     0,
       0,   403,   418,   419,   420,   314,   315,   313,     0,   421,
     422
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   381,    55,   382,   458,   673,   674,   666,
     830,   475,    56,   116,   286,   524,   525,    13,    14,    15,
      89,    57,   243,    58,   249,   244,    59,   295,    60,   297,
     547,    61,    62,   152,   173,   388,   374,    63,   599,   809,
     720,   600,   601,    64,    65,   383,   174,   254,   484,   485,
     229,   650,   230,   231,   663,    16,    17,    18,   259,    19,
      20,    21,   263,   503,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   108,   279,    31,    32,    33,    34,    86,
      66,   296,    67,   538,   539,   540,   701,   603,   604,   389,
     549,   542,    68,   298,   791,   933,   323,   143,   325,   936,
     327,   144,   329,   330,   937,   304,   145,   305,   313,   146,
     147,   148,   793,   149,   353,   557,   794,   846,   847,   558,
     559,   795,    69,    70,    71,    72,   208,   209,   210,   430,
     641,   753,   754,   865,   905,   642,   825,   874,   643,   961,
     822,   862,   863,   864,  1009,  1022,  1023,  1024,   746,   898,
     859,   747,   684,    35,    36,    37,    38,    39,    73,    74,
      75,    76,   446,   922,   878,   826,   759,   438,   439,    77,
      78,   236,   237,    40,    79,    41,    80,    81,    82,   354
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -803
static const yytype_int16 yypact[] =
{
      30,   805,    77,   172,   388,   186,   131,   588,  1002,   377,
     388,   388,   388,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,   139,   191,    47,   174,    78,  -803,
     179,   112,   193,   386,  -803,  -803,  -803,   213,   213,  -803,
    -803,  -803,  1094,  -803,   213,   786,  -803,  -803,  -803,   213,
    1197,   213,  1111,   213,   567,   213,  1215,   213,  1262,  -803,
    -803,   569,  1008,  -803,  -803,  -803,    58,  -803,   220,   241,
    -803,   169,   101,   247,  -803,   264,   212,   264,   283,   347,
     355,   358,   367,   376,   385,  -803,  -803,  -803,   307,   395,
     398,   410,   321,  -803,  -803,  -803,   -19,    58,    35,  -803,
     452,  -803,  -803,  -803,    34,  -803,  -803,   393,   168,  -803,
     280,   290,    -4,   386,  -803,  -803,  -803,   178,   181,   189,
     209,   386,    19,  -803,  -803,  -803,  -803,  -803,   986,  -803,
    1511,  -803,   219,   225,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,   244,    58,   506,   465,    35,   180,  -803,   311,
     311,   514,  -803,   292,   300,   281,   -64,   571,   180,   412,
     432,   421,   518,   467,   319,   608,   507,   615,    35,   528,
     558,   205,   563,   566,   286,   549,   550,   180,   545,   551,
    -803,   489,   488,   452,   180,    35,  -803,  -803,   492,  -803,
     490,   493,   694,   223,  -803,   496,   505,  -803,   747,    35,
     508,    52,    35,    35,   712,   713,   -94,  -803,   511,   512,
    -803,   513,   515,   319,  -803,   516,   -38,   521,   714,   180,
     722,   180,  -803,   523,   530,   531,   724,   773,  -803,   533,
     541,  -803,  -803,   498,   798,   801,  -803,  -803,   264,   802,
    -803,   803,  -803,  1425,   804,   264,   264,   264,   264,   814,
     815,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,   816,
    -803,  -803,  -803,    33,  -803,  1069,   562,  -803,  -803,  -803,
     386,  -803,  -803,  -803,  -803,   564,   595,    69,   573,    34,
    -803,    34,   386,    34,    34,   812,  -803,   813,   326,   807,
     808,    -4,    -4,   809,  -803,   386,   386,   386,   386,    17,
    -803,  -803,   820,  -803,  -803,   811,  -803,  -181,   -10,  -803,
      82,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,   386,   386,   386,   386,   386,
     386,   386,   386,   386,   298,   386,   386,   386,   386,  -803,
    -803,  -803,  -803,  -803,  -803,   452,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  1326,  -803,   386,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,   781,   785,   583,   589,    35,
     817,   180,   319,    35,  -803,  -803,   690,    35,   818,    35,
     693,   819,   691,    35,    35,   180,   827,   600,   799,   603,
     180,   604,   180,   132,  -803,  -803,   611,  -803,  -803,  -803,
      -6,  -803,  -803,   852,   624,   625,  -803,  -803,  -803,   626,
    -803,   627,   825,  -803,  -803,  -803,   628,   629,   630,    35,
      35,   641,   643,   644,  -803,  -803,    20,  -803,    25,  -803,
    -803,  -803,   504,  -803,  -803,  -803,    35,  -803,    35,  -803,
    -803,  -803,  -803,    35,  -803,   319,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,   230,  -803,  -803,  -803,   901,  -803,
    -803,  -803,  -803,   891,   892,  -803,  1326,  -803,  -803,  -803,
     319,  -803,  -803,   898,  -803,  -803,   900,   900,   900,   900,
    -803,  -803,  -803,   657,   660,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,   318,  -803,  -803,   683,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,    13,   661,
     662,  -803,  -803,  -803,   319,    35,  -803,  -803,   520,   595,
    -803,  -803,   736,  -803,  -803,  -803,  -803,    48,  -803,   663,
    -803,  -803,  -803,  -803,  -803,   788,    92,   122,   157,  -803,
     386,   659,   903,    81,  -803,  -803,  -803,   921,   919,  -803,
    1520,  1520,  1520,  1520,  1520,  1520,  1520,  1520,  1520,  -803,
     679,  -803,  -803,  -803,   546,   546,  -803,  -803,  -803,   911,
    -803,   675,  -803,  -803,  -803,  1511,    35,    35,  -803,  -803,
     680,   180,   681,   697,   698,    35,   699,    35,   700,   319,
      35,   729,   730,   731,   733,    35,  -803,    35,  -803,   734,
    -803,   737,   752,   753,   754,  -803,  -803,   138,   783,   769,
     319,   755,  -803,   784,   790,  -803,  -803,  -243,  -803,  -803,
     789,   791,  -803,  -803,  -803,   806,   810,  -803,  -803,  -803,
      35,   317,   342,   822,    35,   319,  -803,  -803,  -803,  -803,
    -803,  -803,    25,  -803,  -803,  -803,   498,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  1060,  1061,  1063,  1070,  -803,  -803,
    -803,  1069,  -803,  -803,  -803,   595,  1026,  -803,  -803,  -803,
    -803,   338,  -803,  -803,   386,  -803,  -803,   386,   386,   386,
     870,  1064,    81,  -803,  -803,   823,   393,  -803,   386,  -803,
     537,  -803,   821,   824,  -803,   826,  -803,  -803,  -803,   829,
    -803,   832,  -803,   833,   834,  -803,  -803,  -803,  -803,   835,
     836,  -803,  -803,  -803,  -803,  -803,  -803,  -803,    35,  -803,
    -803,   452,  -803,  -803,   839,  -803,  -803,  -803,  -803,  -803,
    -803,   825,  -803,  -803,   837,  1079,  1079,  1079,  1079,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,     1,
    -803,  1058,  -803,  -803,   860,   386,  -803,  -803,  -803,   386,
     386,   856,   986,   863,   346,  1085,  -803,   595,  -803,   922,
     945,   954,  -803,   861,  -803,  1066,   977,   319,  -803,  -803,
    -803,  -803,    35,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
     278,  -803,    -3,  -803,  -803,  1260,   -46,  -803,    20,  -803,
     871,   873,   874,   875,   386,   326,   386,  -803,   475,  1387,
     246,  -803,  1115,    43,  -803,  1511,   881,   877,  -803,  -803,
    -803,  -803,  -803,  -803,   883,  -803,  -803,   888,  -803,  -803,
    -803,   -72,  -803,  -803,  -803,   145,    35,    35,    35,   909,
      90,    16,  -803,  -803,   890,    35,   183,  -803,   893,  -803,
      20,    20,    20,    20,   540,   895,   592,   274,  -803,  1114,
      76,   386,   386,   392,   346,  -803,  -803,  -803,  1213,   896,
    -803,   180,    35,   180,  -803,   897,  -803,  -803,  -803,    35,
      35,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,   902,  1026,  1031,  -803,   912,   913,   914,   651,   674,
     924,   925,   926,   927,  -803,   929,    35,   180,    35,    35,
      35,  1013,    35,   108,    79,   176,   978,    35,   963,  -803,
    -803,   934,  -803,  -803,  -803,  -803,  -803,  -803,  -803,   935,
     933,  1114,  1026,  1085,  -803,  -803,  -803,   386,   386,   386,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,    35,  -803,    35,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,   180,  -803,    66,
    -803,  -803,  -803,  -803,  -803,    76,  1000,  1009,  1032,    -5,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,   946,   948,   949,
     -32,  -803,  -803,  -803,  -803,  -803,  -803,  -803,   950,  -803,
    -803
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -803,  -803,  -803,   -82,  -803,  -175,  -178,  -232,   704,  -803,
    -210,  -803,  -803,  -803,  -803,  -803,   519,  -803,  -803,  -803,
    1123,  -803,  -803,  -803,  -803,  -803,  -803,  -199,  -803,  -803,
    -803,  -803,  -803,   654,   434,  1044,  -803,  -803,  -803,  -803,
    -803,   497,  -428,  -803,  -803,  -803,  -803,   -58,  -803,   543,
    -760,   456,  -437,  -803,  -660,  -803,  -803,  -803,   327,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,   576,
    -803,  -803,  -803,  -803,  -520,   525,  -803,   928,   725,   959,
    -803,   684,  -803,  -803,  -778,   252,  -803,  -140,   522,  -134,
    -803,  -135,   665,  -803,   227,  -803,  -803,   210,   341,  -803,
    -803,  -684,  -803,    74,   445,   -53,  -803,  -803,   344,   542,
     409,  -802,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,   141,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,
    -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -803,  -699
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -300
static const yytype_int16 yytable[] =
{
     150,   459,   324,   398,   426,   651,   406,   328,   326,   311,
     647,  1020,   792,   404,   405,   575,   576,   848,   758,   284,
     721,   834,   421,   355,   356,   357,   358,   359,   700,   427,
     693,   502,   320,   321,     1,   127,   291,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   288,   299,   288,   513,
     289,   300,   289,   664,   355,   356,   357,   358,   359,   287,
     636,   301,   451,   892,   467,   873,   469,   893,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    42,   461,   288,
     314,   660,   573,   289,   376,   574,   912,   934,   319,   320,
     321,   251,   713,   843,   320,   321,   252,   713,   355,   356,
     357,   358,   359,   288,   260,   372,   410,   289,   661,   395,
     396,   792,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   288,   443,   428,   875,   289,   462,   117,   355,   356,
     357,   358,   359,   118,    90,   662,   694,   441,   960,   120,
     447,   448,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   288,   899,   887,   970,   289,   112,   452,   453,   463,
     543,   544,   545,   355,   356,   357,   358,   359,   879,   934,
     377,   378,   379,   380,   910,    43,   598,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   257,   900,   931,  1028,
     876,   119,   989,   288,  1004,  1005,   121,   289,   306,   261,
     637,   514,   122,    44,    87,   792,   935,   258,    45,   113,
     123,    46,   377,   378,   379,   380,   877,   638,   464,   639,
     924,   925,   926,   927,   613,   640,   612,  1029,   114,   257,
     151,    47,    48,   913,    49,    88,   914,   527,    87,   115,
     624,    50,   285,   901,   256,   629,   994,   631,   792,   552,
     262,   577,   355,   356,   357,   358,   359,  1021,   835,   860,
     312,    51,   565,   566,   567,   568,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   569,   322,   849,   265,   331,
     570,   257,    52,   991,   668,   665,   271,   792,   792,   792,
     290,   302,   290,   992,   993,  1013,  1014,   672,   303,   632,
     444,   445,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   704,   594,   595,   596,   597,   266,   610,   820,   253,
     278,   614,   672,   290,   651,   616,    53,   618,   546,   633,
     634,   622,   623,   322,   605,   404,   405,   124,   322,   125,
     126,   283,   127,   128,   129,   578,   748,   290,   579,   384,
     272,   130,   131,   902,   132,   707,   133,   124,   273,   125,
     126,   274,   127,   128,   129,   290,   697,   655,   656,   903,
     275,   130,   131,   306,   132,   306,   133,   306,   306,   276,
     385,   386,   413,   414,   669,   708,   670,   917,   277,   134,
     105,   671,   765,   995,   766,   290,   996,   124,   280,   125,
     126,   281,   127,   128,   129,    83,    84,   904,   752,   134,
     106,   130,   131,   282,   132,   107,   133,   767,   589,   768,
     709,   307,   264,   269,   270,   308,    85,   918,   919,   920,
     921,    54,   309,   324,   590,   315,   725,   290,   316,   714,
     591,   733,   310,   328,   267,   268,   317,   592,   593,   134,
     340,   341,   342,   343,   344,   345,   346,   347,   135,   136,
     434,   435,   749,   698,   387,   292,   318,   293,   294,   137,
     138,   139,   417,   418,   140,   348,   349,   350,   135,   136,
     369,   355,   356,   357,   358,   359,   370,   771,   808,   137,
     138,   139,   675,   676,   140,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   201,   371,   207,   890,   215,   550,
     228,   551,   235,   553,   554,   245,   250,   710,   135,   136,
     404,   405,   667,   373,   722,   723,   375,   351,   352,   137,
     138,   139,   391,   729,   140,   731,   940,   941,   734,   858,
     942,   721,   394,   739,   943,   740,   355,   356,   357,   358,
     359,   392,   823,   404,   405,   807,   831,   832,   833,   393,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   478,
     479,   480,   324,   367,   368,   856,   481,   482,   764,   483,
     690,   691,   770,   141,  -299,   488,   109,   110,   111,   397,
     861,   142,   506,   507,   508,   509,   796,   797,   355,   356,
     357,   358,   359,   141,   399,  -294,   163,   400,   163,   401,
     402,   142,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   238,   239,   240,   403,   241,   164,   165,   164,   165,
     166,   167,   166,   167,   169,   170,   169,   170,   529,   530,
     531,   532,   533,   141,   534,   535,   536,   537,   685,   686,
     687,   142,   562,   563,   799,   800,   801,   355,   356,   357,
     358,   359,   171,   407,   171,   806,   821,   408,    91,    92,
     409,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     355,   356,   357,   358,   359,    93,   411,    94,    95,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   153,   529,   530,   531,   532,   533,   162,   534,
     535,   536,   537,   175,   412,   202,   963,   211,   965,   216,
     857,   232,   838,   415,   888,   419,   839,   840,   416,   422,
     420,   845,   355,   356,   357,   358,   359,   423,   424,   425,
     324,   429,   431,   433,   432,   436,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   440,   437,   449,   450,   442,
     454,   455,   983,   466,   456,   460,   457,   468,   699,   473,
     465,   884,   470,   886,   906,   907,   908,    96,   911,   471,
     472,   474,   476,   916,   355,   356,   357,   358,   359,   928,
     477,   486,   212,   213,   487,   489,   490,   505,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   510,   511,   512,
     964,   526,  1012,   528,   555,   163,   556,   967,   968,   214,
     548,   242,   560,   571,   561,   572,   606,   564,   938,   939,
     607,   845,   608,    97,     4,   164,   165,   615,   609,   166,
     167,   930,   168,   169,   170,     5,     6,   619,   621,   626,
     627,   611,   628,   630,   982,   324,   984,   985,   986,   644,
     988,   990,   635,   617,   620,   998,   355,   356,   357,   358,
     359,   171,   625,   645,   646,   648,   649,   652,   653,   654,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   218,
     657,     7,   658,   659,   677,  1010,     8,  1011,   678,   679,
     975,     9,    10,    11,    12,   682,   688,  1015,   683,   689,
     695,   705,   711,   696,  1006,  1007,  1008,   712,   355,   356,
     357,   358,   359,   976,   715,   716,   718,   719,   721,   724,
     726,   692,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   355,   356,   357,   358,   359,   727,   728,   730,   732,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   355,   356,   357,   358,   359,   735,   736,
     737,   331,   738,   741,   703,   751,   742,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   355,   356,   357,   358,
     359,   743,   744,   745,   755,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   355,   356,
     357,   358,   359,   779,   750,   756,   706,   163,   172,   757,
     761,   760,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   332,   246,   773,   774,   762,   775,   164,   165,   763,
     780,   166,   167,   776,    98,   169,   170,   803,   836,   854,
     811,   909,    99,   100,   769,   813,   805,   812,   814,   781,
     247,   815,   816,   817,   818,   819,   828,   829,  -196,  -196,
     824,  -196,   779,   171,   101,   102,   103,   104,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   837,   841,   853,
     333,   334,   844,   335,   336,   337,   338,   339,   802,   780,
     880,   779,   881,   882,   883,   891,   895,   782,   783,   784,
     785,   786,   787,   788,   894,   896,   154,   897,   781,   915,
     163,   155,   923,   929,   789,   962,   966,   790,   780,   156,
     969,   971,   340,   341,   342,   343,   344,   345,   346,   347,
     164,   165,   972,   973,   166,   167,   974,   781,   169,   170,
     850,   977,   978,   979,   157,   987,   980,   348,   349,   350,
     981,   999,   997,  1000,  1001,  1002,   782,   783,   784,   785,
     786,   787,   788,   851,   681,  1025,   171,  1026,  1027,  1030,
     777,   255,   852,   789,   390,  -196,   790,   827,   810,   772,
     778,   680,   504,  1003,   541,   782,   783,   784,   785,   786,
     787,   788,  1016,   702,   804,   855,   163,   842,   944,   351,
     352,   176,   789,   717,   885,   790,   798,     0,     0,     0,
       0,     0,     0,     0,   163,     0,   164,   165,  1017,     0,
     166,   167,     0,     0,   169,   170,     0,  1018,     0,     0,
     248,   177,     0,   178,   164,   165,     0,     0,   166,   167,
       0,   217,   169,   170,     0,     0,     0,   218,  -196,   218,
    1019,     0,   171,   158,     0,     0,   179,     0,     0,     0,
       0,   163,     0,     0,   180,   181,     0,   220,   219,   220,
     171,   203,     0,     0,     0,     0,   204,   945,   205,     0,
       0,   164,   165,     0,     0,   166,   167,     0,   159,   169,
     170,     0,     0,   160,   218,   182,     0,     0,     0,     0,
       0,     0,  -196,   602,     0,     0,     0,  -196,     0,   161,
       0,     0,   183,   184,   220,   185,   186,   171,   187,   188,
     189,   233,   190,     0,     0,   191,   192,     0,   193,     0,
       0,     0,     0,   206,     0,   932,     0,     0,     0,     0,
       0,   194,   195,     0,     0,     0,   196,   946,   197,     0,
     198,     0,   199,   355,   356,   357,   358,   359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   360,   361,   362,
     363,   364,   365,   366,   367,   368,     0,     0,     0,   947,
       0,   948,   949,   950,   951,   952,   953,     0,   491,   954,
       0,   955,   956,   221,   866,   957,     0,     0,     0,     0,
     958,   404,   405,     0,   529,   530,   531,   532,   533,     0,
     534,   535,   536,   537,     0,   222,   223,   224,   225,   200,
       0,     0,     0,   492,     0,   226,     0,     0,     0,   867,
     868,   869,     0,   870,     0,   959,     0,   227,   871,     0,
       0,     0,     0,     0,   493,     0,     0,   494,     0,     0,
       0,     0,     0,   495,   496,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   497,   498,   499,
     500,     0,   501,     0,     0,     0,   889,   355,   356,   357,
     358,   359,   872,     0,   234,     0,  -300,  -300,  -300,  -300,
    -300,   360,   361,   362,   363,   364,   365,   366,   367,   368,
    -300,  -300,  -300,  -300,  -300,   365,   366,   367,   368,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   387
};

static const yytype_int16 yycheck[] =
{
      53,   233,   142,   178,   203,   442,   184,   142,   142,    13,
     438,    16,   696,    16,    17,    25,    26,   795,   261,    38,
     263,    20,   197,     6,     7,     8,     9,    10,   548,   204,
      17,   263,    13,    14,     4,    16,   118,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    13,    13,    13,    16,
      17,    17,    17,    28,     6,     7,     8,     9,    10,   117,
      66,    27,   156,    20,   239,   825,   241,    24,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     0,   116,    13,
     133,    61,   263,    17,   166,   266,    70,   889,   141,    13,
      14,    33,    16,   792,    13,    14,    38,    16,     6,     7,
       8,     9,    10,    13,     3,   163,   188,    17,    88,   173,
     174,   795,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    13,    70,   205,   170,    17,   164,    80,     6,     7,
       8,     9,    10,    86,     3,   115,   123,   219,   898,    61,
     222,   223,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    13,   224,   837,   932,    17,    17,   251,   252,   197,
      91,    92,    93,     6,     7,     8,     9,    10,   828,   971,
      32,    33,    34,    35,    84,     3,   375,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    17,   259,   887,   221,
     236,    17,    84,    13,   972,   973,    17,    17,   124,    98,
     206,   283,    90,    31,    18,   889,   130,    38,    36,    18,
      17,    39,    32,    33,    34,    35,   262,   223,   256,   225,
     880,   881,   882,   883,   402,   231,   401,   259,    37,    17,
      17,    59,    60,   217,    62,    49,   220,   290,    18,    48,
     415,    69,   261,    98,     3,   420,    70,   422,   932,   302,
       3,   261,     6,     7,     8,     9,    10,   262,   257,   262,
     264,    89,   315,   316,   317,   318,    20,    21,    22,    23,
      24,    25,    26,    27,    28,   258,   257,   797,    66,     5,
     263,    17,   110,   204,   462,   260,     3,   971,   972,   973,
     257,   257,   257,   214,   215,   229,   230,   475,   264,   167,
     248,   249,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   263,   365,   366,   367,   368,   104,   399,   746,   261,
      13,   403,   500,   257,   761,   407,   154,   409,   259,   197,
     198,   413,   414,   257,   387,    16,    17,    11,   257,    13,
      14,    20,    16,    17,    18,   263,   208,   257,   266,    38,
       3,    25,    26,   208,    28,   263,    30,    11,     3,    13,
      14,     3,    16,    17,    18,   257,   544,   449,   450,   224,
       3,    25,    26,   299,    28,   301,    30,   303,   304,     3,
      69,    70,   177,   178,   466,   263,   468,   204,     3,    63,
      13,   473,    75,   217,    77,   257,   220,    11,     3,    13,
      14,     3,    16,    17,    18,    17,    18,   262,   640,    63,
      33,    25,    26,     3,    28,    38,    30,    75,   120,    77,
     263,    28,    95,    96,    97,   257,    38,   244,   245,   246,
     247,   259,   152,   573,   136,   257,   611,   257,   257,   573,
     142,   619,   152,   578,   232,   233,   257,   149,   150,    63,
     176,   177,   178,   179,   180,   181,   182,   183,   132,   133,
     237,   238,   637,   545,   153,    13,   257,    15,    16,   143,
     144,   145,   186,   187,   148,   201,   202,   203,   132,   133,
     261,     6,     7,     8,     9,    10,   261,   665,   720,   143,
     144,   145,   262,   263,   148,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    70,   261,    72,   261,    74,   299,
      76,   301,    78,   303,   304,    81,    82,   570,   132,   133,
      16,    17,    18,    17,   606,   607,    61,   253,   254,   143,
     144,   145,    18,   615,   148,   617,   144,   145,   620,   261,
     148,   263,   261,   625,   152,   627,     6,     7,     8,     9,
      10,   259,   751,    16,    17,    18,   766,   767,   768,   259,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    71,
      72,    73,   712,    27,    28,   807,    78,    79,   660,    81,
     262,   263,   664,   257,   258,   258,    10,    11,    12,    18,
     822,   265,   265,   266,   267,   268,   258,   259,     6,     7,
       8,     9,    10,   257,   192,   259,    39,   175,    39,   188,
      92,   265,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    52,    53,    54,   157,    56,    59,    60,    59,    60,
      63,    64,    63,    64,    67,    68,    67,    68,   118,   119,
     120,   121,   122,   257,   124,   125,   126,   127,   507,   508,
     509,   265,   311,   312,   707,   708,   709,     6,     7,     8,
       9,    10,    95,    55,    95,   718,   748,   160,    80,    81,
      55,    20,    21,    22,    23,    24,    25,    26,    27,    28,
       6,     7,     8,     9,    10,    97,   158,    99,   100,     6,
       7,     8,     9,    10,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    58,   118,   119,   120,   121,   122,    64,   124,
     125,   126,   127,    69,   166,    71,   901,    73,   903,    75,
     812,    77,   785,   170,   259,   186,   789,   790,   172,   194,
     190,   794,     6,     7,     8,     9,    10,   196,   259,   261,
     890,   259,   262,    59,   261,   259,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    18,   261,    55,    55,   261,
     259,   259,   947,    59,   261,   259,   261,    55,   258,    55,
     259,   834,   259,   836,   866,   867,   868,   199,   870,   259,
     259,    18,   259,   875,     6,     7,     8,     9,    10,   259,
     259,     3,   235,   236,     3,     3,     3,     3,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     3,     3,     3,
     902,   259,   997,   259,    12,    39,    13,   909,   910,   262,
     257,   262,    25,    13,    26,    24,    55,    28,   891,   892,
      55,   894,   259,   255,    39,    59,    60,   157,   259,    63,
      64,   259,    66,    67,    68,    50,    51,   164,   167,   259,
      61,    44,   259,   259,   946,  1005,   948,   949,   950,    17,
     952,   953,   261,    55,    55,   957,     6,     7,     8,     9,
      10,    95,    55,   259,   259,   259,   259,   259,   259,   259,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    74,
     259,    96,   259,   259,     3,   987,   101,   989,    17,    17,
     259,   106,   107,   108,   109,    17,   259,   999,    18,   259,
     259,   258,   263,   261,   977,   978,   979,    24,     6,     7,
       8,     9,    10,   259,    13,    16,   257,    26,   263,   259,
     259,   258,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     6,     7,     8,     9,    10,   259,   259,   259,   259,
       6,     7,     8,     9,    10,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    20,    21,    22,    23,    24,    25,
      26,    27,    28,     6,     7,     8,     9,    10,   259,   259,
     259,     5,   259,   259,   258,   226,   259,    20,    21,    22,
      23,    24,    25,    26,    27,    28,     6,     7,     8,     9,
      10,   259,   259,   259,   259,     6,     7,     8,     9,    10,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     6,     7,
       8,     9,    10,    17,   261,   261,   258,    39,   262,   259,
     259,   262,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    75,    54,     3,     3,   259,     3,    59,    60,   259,
      44,    63,    64,     3,    72,    67,    68,    13,    20,    13,
     259,   172,    80,    81,   262,   259,   263,   263,   259,    63,
      82,   259,   259,   259,   259,   259,   259,    18,    13,    14,
     261,    16,    17,    95,   102,   103,   104,   105,    39,    40,
      41,    42,    43,    44,    45,    46,    47,   257,   262,   258,
     134,   135,   259,   137,   138,   139,   140,   141,   258,    44,
     259,    17,   259,   259,   259,    20,   259,   111,   112,   113,
     114,   115,   116,   117,   263,   262,    52,   259,    63,   259,
      39,    57,   259,   258,   128,   259,   259,   131,    44,    65,
     258,   130,   176,   177,   178,   179,   180,   181,   182,   183,
      59,    60,   260,   260,    63,    64,   262,    63,    67,    68,
     258,   257,   257,   257,    90,   172,   259,   201,   202,   203,
     261,   228,   214,   259,   259,   262,   111,   112,   113,   114,
     115,   116,   117,   258,   500,   259,    95,   259,   259,   259,
     691,    88,   258,   128,   170,   130,   131,   761,   721,   676,
     695,   496,   263,   971,   296,   111,   112,   113,   114,   115,
     116,   117,  1005,   549,   712,   258,    39,   792,   894,   253,
     254,    44,   128,   578,   835,   131,   704,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    -1,    59,    60,   258,    -1,
      63,    64,    -1,    -1,    67,    68,    -1,   258,    -1,    -1,
     262,    74,    -1,    76,    59,    60,    -1,    -1,    63,    64,
      -1,    66,    67,    68,    -1,    -1,    -1,    74,   262,    74,
     258,    -1,    95,   199,    -1,    -1,    99,    -1,    -1,    -1,
      -1,    39,    -1,    -1,   107,   108,    -1,    94,    93,    94,
      95,   200,    -1,    -1,    -1,    -1,   205,   104,   207,    -1,
      -1,    59,    60,    -1,    -1,    63,    64,    -1,   234,    67,
      68,    -1,    -1,   239,    74,   138,    -1,    -1,    -1,    -1,
      -1,    -1,   257,    17,    -1,    -1,    -1,   262,    -1,   255,
      -1,    -1,   155,   156,    94,   158,   159,    95,   161,   162,
     163,    99,   165,    -1,    -1,   168,   169,    -1,   171,    -1,
      -1,    -1,    -1,   262,    -1,   261,    -1,    -1,    -1,    -1,
      -1,   184,   185,    -1,    -1,    -1,   189,   174,   191,    -1,
     193,    -1,   195,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    -1,    -1,   206,
      -1,   208,   209,   210,   211,   212,   213,    -1,     3,   216,
      -1,   218,   219,   218,   174,   222,    -1,    -1,    -1,    -1,
     227,    16,    17,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,    -1,   240,   241,   242,   243,   262,
      -1,    -1,    -1,    38,    -1,   250,    -1,    -1,    -1,   209,
     210,   211,    -1,   213,    -1,   262,    -1,   262,   218,    -1,
      -1,    -1,    -1,    -1,    59,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    -1,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    84,
      85,    -1,    87,    -1,    -1,    -1,   129,     6,     7,     8,
       9,    10,   262,    -1,   262,    -1,     6,     7,     8,     9,
      10,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   268,   269,    39,    50,    51,    96,   101,   106,
     107,   108,   109,   284,   285,   286,   322,   323,   324,   326,
     327,   328,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   342,   343,   344,   345,   420,   421,   422,   423,   424,
     440,   442,     0,     3,    31,    36,    39,    59,    60,    62,
      69,    89,   110,   154,   259,   271,   279,   288,   290,   293,
     295,   298,   299,   304,   310,   311,   347,   349,   359,   389,
     390,   391,   392,   425,   426,   427,   428,   436,   437,   441,
     443,   444,   445,    17,    18,    38,   346,    18,    49,   287,
       3,    80,    81,    97,    99,   100,   199,   255,    72,    80,
      81,   102,   103,   104,   105,    13,    33,    38,   340,   346,
     346,   346,    17,    18,    37,    48,   280,    80,    86,    17,
      61,    17,    90,    17,    11,    13,    14,    16,    17,    18,
      25,    26,    28,    30,    63,   132,   133,   143,   144,   145,
     148,   257,   265,   364,   368,   373,   376,   377,   378,   380,
     382,    17,   300,   300,    52,    57,    65,    90,   199,   234,
     239,   255,   300,    39,    59,    60,    63,    64,    66,    67,
      68,    95,   262,   301,   313,   300,    44,    74,    76,    99,
     107,   108,   138,   155,   156,   158,   159,   161,   162,   163,
     165,   168,   169,   171,   184,   185,   189,   191,   193,   195,
     262,   301,   300,   200,   205,   207,   262,   301,   393,   394,
     395,   300,   235,   236,   262,   301,   300,    66,    74,    93,
      94,   218,   240,   241,   242,   243,   250,   262,   301,   317,
     319,   320,   300,    99,   262,   301,   438,   439,    52,    53,
      54,    56,   262,   289,   292,   301,    54,    82,   262,   291,
     301,    33,    38,   261,   314,   287,     3,    17,    38,   325,
       3,    98,     3,   329,   325,    66,   104,   232,   233,   325,
     325,     3,     3,     3,     3,     3,     3,     3,    13,   341,
       3,     3,     3,    20,    38,   261,   281,   314,    13,    17,
     257,   270,    13,    15,    16,   294,   348,   296,   360,    13,
      17,    27,   257,   264,   372,   374,   380,    28,   257,   152,
     152,    13,   264,   375,   382,   257,   257,   257,   257,   382,
      13,    14,   257,   363,   364,   365,   366,   367,   368,   369,
     370,     5,    75,   134,   135,   137,   138,   139,   140,   141,
     176,   177,   178,   179,   180,   181,   182,   183,   201,   202,
     203,   253,   254,   381,   446,     6,     7,     8,     9,    10,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   261,
     261,   261,   314,    17,   303,    61,   270,    32,    33,    34,
      35,   270,   272,   312,    38,    69,    70,   153,   302,   356,
     302,    18,   259,   259,   261,   173,   174,    18,   272,   192,
     175,   188,    92,   157,    16,    17,   273,    55,   160,    55,
     270,   158,   166,   177,   178,   170,   172,   186,   187,   186,
     190,   272,   194,   196,   259,   261,   294,   272,   270,   259,
     396,   262,   261,    59,   237,   238,   259,   261,   434,   435,
      18,   270,   261,    70,   248,   249,   429,   270,   270,    55,
      55,   156,   251,   252,   259,   259,   261,   261,   273,   274,
     259,   116,   164,   197,   256,   259,    59,   272,    55,   272,
     259,   259,   259,    55,    18,   278,   259,   259,    71,    72,
      73,    78,    79,    81,   315,   316,     3,     3,   325,     3,
       3,     3,    38,    59,    62,    68,    69,    82,    83,    84,
      85,    87,   274,   330,   356,     3,   325,   325,   325,   325,
       3,     3,     3,    16,   270,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   282,   283,   259,   382,   259,   118,
     119,   120,   121,   122,   124,   125,   126,   127,   350,   351,
     352,   354,   358,    91,    92,    93,   259,   297,   257,   357,
     374,   374,   382,   374,   374,    12,    13,   382,   386,   387,
      25,    26,   375,   375,    28,   382,   382,   382,   382,   258,
     263,    13,    24,   263,   266,    25,    26,   261,   263,   266,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   120,
     136,   142,   149,   150,   382,   382,   382,   382,   294,   305,
     308,   309,    17,   354,   355,   382,    55,    55,   259,   259,
     270,    44,   272,   273,   270,   157,   270,    55,   270,   164,
      55,   167,   270,   270,   272,    55,   259,    61,   259,   272,
     259,   272,   167,   197,   198,   261,    66,   206,   223,   225,
     231,   397,   402,   405,    17,   259,   259,   309,   259,   259,
     318,   319,   259,   259,   259,   270,   270,   259,   259,   259,
      61,    88,   115,   321,    28,   260,   276,    18,   273,   270,
     270,   270,   273,   274,   275,   262,   263,     3,    17,    17,
     355,   275,    17,    18,   419,   419,   419,   419,   259,   259,
     262,   263,   258,    17,   123,   259,   261,   273,   270,   258,
     351,   353,   358,   258,   263,   258,   258,   263,   263,   263,
     382,   263,    24,    16,   366,    13,    16,   369,   257,    26,
     307,   263,   270,   270,   259,   272,   259,   259,   259,   270,
     259,   270,   259,   273,   270,   259,   259,   259,   259,   270,
     270,   259,   259,   259,   259,   259,   415,   418,   208,   272,
     261,   226,   274,   398,   399,   259,   261,   259,   261,   433,
     262,   259,   259,   259,   270,    75,    77,    75,    77,   262,
     270,   273,   316,     3,     3,     3,     3,   283,   352,    17,
      44,    63,   111,   112,   113,   114,   115,   116,   117,   128,
     131,   361,   378,   379,   383,   388,   258,   259,   386,   382,
     382,   382,   258,    13,   365,   263,   382,    18,   274,   306,
     308,   259,   263,   259,   259,   259,   259,   259,   259,   259,
     309,   270,   407,   294,   261,   403,   432,   318,   259,    18,
     277,   277,   277,   277,    20,   257,    20,   257,   382,   382,
     382,   262,   381,   446,   259,   382,   384,   385,   361,   351,
     258,   258,   258,   258,    13,   258,   274,   270,   261,   417,
     262,   274,   408,   409,   410,   400,   174,   209,   210,   211,
     213,   218,   262,   317,   404,   170,   236,   262,   431,   321,
     259,   259,   259,   259,   382,   387,   382,   378,   259,   129,
     261,    20,    20,    24,   263,   259,   262,   259,   416,   224,
     259,    98,   208,   224,   262,   401,   270,   270,   270,   172,
      84,   270,    70,   217,   220,   259,   270,   204,   244,   245,
     246,   247,   430,   259,   321,   321,   321,   321,   259,   258,
     259,   446,   261,   362,   388,   130,   366,   371,   382,   382,
     144,   145,   148,   152,   385,   104,   174,   206,   208,   209,
     210,   211,   212,   213,   216,   218,   219,   222,   227,   262,
     317,   406,   259,   272,   270,   272,   259,   270,   270,   258,
     361,   130,   260,   260,   262,   259,   259,   257,   257,   257,
     259,   261,   270,   272,   270,   270,   270,   172,   270,    84,
     270,   204,   214,   215,    70,   217,   220,   214,   270,   228,
     259,   259,   262,   362,   361,   361,   382,   382,   382,   411,
     270,   270,   272,   229,   230,   270,   371,   258,   258,   258,
      16,   262,   412,   413,   414,   259,   259,   259,   221,   259,
     259
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 293 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 294 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 307 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 308 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 312 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 316 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 325 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 326 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 327 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 328 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 329 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 330 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 337 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 344 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 352 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 356 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 360 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 367 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 375 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 376 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 382 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 391 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 396 "cf-parse.y"
    { (yyval.g) = NULL; ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 397 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 401 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 402 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 406 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 407 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 411 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 412 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 413 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 415 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 416 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 417 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 418 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 419 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 427 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 430 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 433 "cf-parse.y"
    { cli_msg(7, "Shutdown requested"); order_shutdown(); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 436 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 445 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 461 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 462 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 466 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 478 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 491 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 495 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 508 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 520 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 526 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 528 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 547 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 548 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 549 "cf-parse.y"
    { new_config->listen_bgp_flags |= SKF_V6ONLY; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 556 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 568 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 574 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 582 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 586 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 587 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 588 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 589 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 590 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 591 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 592 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 596 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 598 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 599 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 603 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 611 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 612 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 618 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 626 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 627 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 628 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 632 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 633 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 650 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 665 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 680 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 681 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 682 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 687 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 691 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 692 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 693 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 694 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 695 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 696 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 717 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 735 "cf-parse.y"
    { ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 736 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 737 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 738 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 739 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 740 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 749 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 752 "cf-parse.y"
    { proto_show((yyvsp[(3) - (4)].s), 0); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 755 "cf-parse.y"
    { proto_show((yyvsp[(4) - (5)].s), 1); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 763 "cf-parse.y"
    { if_show(); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 766 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 769 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 772 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 778 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 784 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 791 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 796 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 801 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 806 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 810 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 814 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 824 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 832 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 836 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 843 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 844 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 848 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 852 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 854 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 856 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 858 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 860 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 862 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 864 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 866 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 878 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 879 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 886 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 0); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 888 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 1); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 890 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), 2); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 894 "cf-parse.y"
    { proto_debug((yyvsp[(2) - (4)].t), (yyvsp[(3) - (4)].i)); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 898 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].s)->name; ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 899 "cf-parse.y"
    { (yyval.t) = "*"; ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 906 "cf-parse.y"
    { cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 906 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s) = cf_define_symbol((yyvsp[(2) - (4)].s), SYM_FILTER, (yyvsp[(4) - (4)].f));
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 915 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 919 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 921 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 922 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 923 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 924 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 925 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 926 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 927 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 928 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_IP:
	  case T_PAIR:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 947 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 958 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 959 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 966 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 967 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 974 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 983 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 991 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1015 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1016 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1020 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1026 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1029 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1040 "cf-parse.y"
    {
     if ((yyvsp[(1) - (2)].x)) {
       if ((yyvsp[(1) - (2)].x)->next)
	 bug("Command has next already set");
       (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x);
       (yyval.x) = (yyvsp[(1) - (2)].x);
     } else (yyval.x) = (yyvsp[(2) - (2)].x);
   ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1051 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1054 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1063 "cf-parse.y"
    { (yyval.i) = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1070 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1074 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1075 "cf-parse.y"
    { (yyval.v).type = T_PAIR; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1076 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1077 "cf-parse.y"
    {  (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1081 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1086 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1094 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1095 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1099 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1106 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1107 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1108 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1109 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1116 "cf-parse.y"
    { (yyval.trie) = f_new_trie(); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1117 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1120 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1121 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(1) - (4)].e);
     (yyval.e)->data = (yyvsp[(3) - (4)].x);
     (yyval.e)->left = (yyvsp[(4) - (4)].e);
   ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1126 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1137 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1138 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1142 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1143 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1147 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1148 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1150 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1151 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1161 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1174 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1175 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1176 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1177 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1178 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1179 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1180 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1181 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1182 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1183 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1197 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1220 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1253 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1255 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1256 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1257 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1258 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1259 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1261 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1268 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1269 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1270 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1271 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1272 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1273 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1274 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1276 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1277 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1278 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1279 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1280 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1282 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1283 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1284 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1286 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1288 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1290 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1292 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1293 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1294 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1295 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1296 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1306 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1307 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1310 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1315 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1338 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1339 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1340 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1341 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1342 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1343 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1347 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1352 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1361 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1368 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1377 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1378 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1382 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1388 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1398 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1407 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1413 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1418 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1425 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1430 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1436 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1437 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1438 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1447 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1448 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1450 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_as4 = bgp_as4_support;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
 ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1476 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 1477 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 1483 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i); ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1484 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1485 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1486 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1487 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1488 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1489 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1490 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (6)].i); BGP_CFG->multihop_via = (yyvsp[(5) - (6)].a); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1491 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1492 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1493 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1494 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1496 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1497 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1498 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1499 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1500 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1501 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1502 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1503 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1504 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1505 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1506 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1507 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1508 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1509 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1518 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1534 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 1535 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i) ; if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 1539 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (3)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->vlink_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1560 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 1561 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 1574 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 1588 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1589 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 1590 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 1594 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 1604 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 1605 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 1606 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 1607 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1608 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1609 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1610 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1611 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1612 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1617 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1638 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1639 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 1640 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1641 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1642 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1643 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1644 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1645 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1646 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1647 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1648 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1649 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1650 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1651 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1653 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1654 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 1655 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 1656 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1657 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1658 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) cf_error("Buffer size is too small") ; ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 1672 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 1681 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 1700 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 1709 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 1719 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->strictnbma = 0;
  OSPF_PATT->stub = 0;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 1752 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 1762 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 1765 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 1768 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1771 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0); ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1774 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1779 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_OPAQUE;
  ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 1789 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1794 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 1795 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 1801 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1810 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1811 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 1812 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 1813 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1814 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1815 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1817 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1818 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 1819 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 1831 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1832 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 1835 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 1839 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1840 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 1854 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 1870 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1882 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&((struct static_config *) this_proto)->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 1891 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 1895 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&((struct static_config *) this_proto)->iface_routes, &this_srt->n);
   ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 1901 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 1902 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 1903 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 1907 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 1915 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 1915 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 1925 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 1926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 6363 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1928 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


